	.module	timer_handler.ms

	MAX_BEATS	=	8
	CH1_FREQ_LOW	=	0x13
	CH1_FREQ_HI	=	0x14
	CH1_ENV		=	0x12
	SND_STAT	=	0x26
	CH2_FREQ_LOW	=	0x18
	CH2_FREQ_HI	=	0x19
	CH2_ENV		=	0x17

	.area	_BSS
_beat_tones::
beat_tones::
	.ds	MAX_BEATS*2
_beat_last::
beat_last::
	.ds	1
_beat_current::
beat_current::
	.ds	1
_beat_current_tone::
beat_current_tone::
	.ds	2
_beat_current_time::
beat_current_time::
	.ds	1
_beat_period::
beat_period::
	.ds	1
beat_off_time::
	.ds	1
	.area	_CODE
_timer_handler::
	ld	hl,#beat_off_time
	dec	(hl)		; Bit of a hack
	jr	nz,_timer_handler_not_off
	ld	a,#0xF2
	ldh	(CH1_ENV),a
	ldh	(CH2_ENV),a
_timer_handler_not_off::
	ld	hl,#beat_current_time
	dec	(hl)
	ret	nz
				; Time has expired
	ld	a,(beat_period)
	ld	(hl),a
	ld	a,#25		; 0.2 seconds
	ld	(beat_off_time),a

	ld	a,#0x80
	ldh	(SND_STAT),a
	ld	hl,#beat_current_tone
	ld	a,(hl+)
	ld	h,(hl)
	ld	l,a
	ld	a,(hl+)
	ldh	(CH1_FREQ_LOW),a
	ldh	(CH2_FREQ_LOW),a
	ld	a,#0xF0		; Max volume, quick decay
	ldh	(CH1_ENV),a
	ldh	(CH2_ENV),a
	ld	a,(hl+)
	or	#0x80
	ldh	(CH1_FREQ_HI),a
	ldh	(CH2_FREQ_HI),a
	ld      a,l
	ld	(beat_current_tone+0),a
	ld	a,h
	ld	(beat_current_tone+1),a

	ld	hl,#beat_current
	inc	(hl)
	ld	a,(beat_last)
	cp	(hl)
	ret	nz

	ld	(hl),#0

	ld	hl,#beat_tones
	ld	a,l
	ld	(beat_current_tone+0),a
	ld	a,h
	ld	(beat_current_tone+1),a

	ret

